[![Build Status](https://travis-ci.org/CESNET/perun.svg?branch=master)](https://travis-ci.org/CESNET/perun)

<a href="https://perun.cesnet.cz/"><img style="float: left; position: relative;" src="https://raw.githubusercontent.com/CESNET/perun/master/perun-web-gui/src/main/webapp/img/logo.png"></a>
## Identity & Access Management System ##

Perun is an identity and access management system primary targeting academia environment. Perun is well suited for managing users within organizations and projects and managing access rights to the services.

### Features ###

* Simplify and automate all identity management related workflows
* Perform access management by provisioning and deprovisioning users to your services
* Support delegation of user/service management responsibilities
* Unified GUI as a single place for managing everything from personal profile to groups and services settings
* Organize users within groups and virtual organizations
* Handle whole user lifecycle from registration to membership expiration / extension
* Allow users to self register using invitations
* Support import/export and synchronization between your existing user databases
* Can handle and join multiple user identities a manage them across your services
* All actions are audited

### Changelog ###

* [Changelog web](https://perun.cesnet.cz/web/documentation.shtml)
* [Changelog RSS](https://perun.cesnet.cz/web/release-rss.xml)

### Related projects ###

* [Perun ansible](https://github.com/CESNET/perun-ansible) - Perun installation automation using Ansible
* [Perun services](https://github.com/CESNET/perun-services) - connectors Perun uses to manage services
* [Perun WUI](https://github.com/zlamalp/perun-wui) - next-gen web user interface for Perun
* [Google Group connector](https://github.com/CESNET/google-group-connector) - allow provisioning of Google groups on your domain

### License ###

&copy; 2010-2018 [CESNET](https://www.cesnet.cz/?lang=en) and [CERIT-SC](https://www.cerit-sc.cz/en/index.html), all rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
