package cz.metacentrum.perun.core.implApi.modules.attributes;


import cz.metacentrum.perun.core.api.Attribute;
import cz.metacentrum.perun.core.api.AttributeDefinition;
import cz.metacentrum.perun.core.api.Group;
import cz.metacentrum.perun.core.api.exceptions.InternalErrorException;
import cz.metacentrum.perun.core.impl.PerunSessionImpl;

/**
 * This interface serves as a template for virtual attributes.
 *
 * @author Pavel Vyskocil <vyskocilpavel@muni.cz>
 */

public interface GroupVirtualAttributesModuleImplApi extends GroupAttributesModuleImplApi, VirtualAttributesModuleImplApi{
	/**
	 * This method will return computed value.
	 *
	 * @param perunSession perun session
	 * @param group group which is needed for computing the value
	 * @param attribute attribute to operate on
	 * @return
	 * @throws InternalErrorException if an exception is raised in particular
	 *         implementation, the exception is wrapped in InternalErrorException
	 */
	Attribute getAttributeValue(PerunSessionImpl perunSession, Group group, AttributeDefinition attribute) throws InternalErrorException;

	/**
	 * Method sets attributes' values which are dependent on this virtual attribute.
	 *
	 * @param perunSession
	 * @param group group which is needed for computing the value
	 * @param attribute attribute to operate on
	 * @return true if attribute was really changed
	 */
	boolean setAttributeValue(PerunSessionImpl perunSession, Group group, Attribute attribute);

	/**
	 * Currently do nothing.
	 *
	 * @param perunSession
	 * @param group group which is needed for computing the value
	 * @param attribute attribute to operate on
	 * @return
	 */
	void removeAttributeValue(PerunSessionImpl perunSession, Group group, AttributeDefinition attribute);
}
